/*
 Navicat Premium Data Transfer

 Source Server         : vsdn-192.168.200.24
 Source Server Type    : MySQL
 Source Server Version : 100136
 Source Host           : 192.168.200.24:3306
 Source Schema         : soooner_hotel

 Target Server Type    : MySQL
 Target Server Version : 100136
 File Encoding         : 65001

 Date: 10/06/2019 13:34:31
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for action_log
-- ----------------------------
DROP TABLE IF EXISTS `action_log`;
CREATE TABLE `action_log` (
  `VAL_ID` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `VAL_LOGINID` varchar(145) NOT NULL COMMENT '用户',
  `VAL_TIME` datetime NOT NULL COMMENT '在什么时间',
  `VAL_MODEL_RESOURCE` varchar(255) NOT NULL COMMENT '在什么地方',
  `VAL_ACTION` varchar(45) NOT NULL COMMENT '动作类型：添加、修改、删除、禁用|启用、选择；如：点播资源分配增加、模块选择资源等',
  `VAL_OBJECT` text NOT NULL COMMENT '内容对象',
  `VAL_IP` varchar(45) NOT NULL COMMENT '操作地址',
  `VAL_COMMAND_NAME` varchar(45) NOT NULL COMMENT '命令标志，Add、Delete、Edit、Forbid等',
  PRIMARY KEY (`VAL_ID`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='操作日志';

-- ----------------------------
-- Table structure for login_valid
-- ----------------------------
DROP TABLE IF EXISTS `login_valid`;
CREATE TABLE `login_valid` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `ip` varchar(128) DEFAULT NULL COMMENT '客户端ip',
  `time` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  `login_num` int(11) DEFAULT '0',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `ip` (`ip`) USING BTREE COMMENT 'ip索引'
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Table structure for rbac_access
-- ----------------------------
DROP TABLE IF EXISTS `rbac_access`;
CREATE TABLE `rbac_access` (
  `role_id` smallint(6) unsigned NOT NULL,
  `menu_id` smallint(6) unsigned NOT NULL,
  KEY `groupId` (`role_id`) USING BTREE,
  KEY `nodeId` (`menu_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='角色菜单关联表';

-- ----------------------------
-- Records of rbac_access
-- ----------------------------
BEGIN;
INSERT INTO `rbac_access` VALUES (5, 1);
INSERT INTO `rbac_access` VALUES (5, 2);
INSERT INTO `rbac_access` VALUES (5, 3);
INSERT INTO `rbac_access` VALUES (5, 4);
INSERT INTO `rbac_access` VALUES (5, 5);
INSERT INTO `rbac_access` VALUES (5, 6);
INSERT INTO `rbac_access` VALUES (5, 7);
INSERT INTO `rbac_access` VALUES (5, 8);
INSERT INTO `rbac_access` VALUES (5, 9);
INSERT INTO `rbac_access` VALUES (5, 10);
INSERT INTO `rbac_access` VALUES (5, 11);
INSERT INTO `rbac_access` VALUES (5, 12);
INSERT INTO `rbac_access` VALUES (5, 13);
INSERT INTO `rbac_access` VALUES (5, 14);
INSERT INTO `rbac_access` VALUES (5, 15);
INSERT INTO `rbac_access` VALUES (5, 16);
INSERT INTO `rbac_access` VALUES (5, 17);
INSERT INTO `rbac_access` VALUES (5, 18);
INSERT INTO `rbac_access` VALUES (5, 114);
INSERT INTO `rbac_access` VALUES (5, 115);
INSERT INTO `rbac_access` VALUES (30, 1);
INSERT INTO `rbac_access` VALUES (30, 2);
INSERT INTO `rbac_access` VALUES (30, 3);
INSERT INTO `rbac_access` VALUES (30, 4);
INSERT INTO `rbac_access` VALUES (30, 5);
INSERT INTO `rbac_access` VALUES (30, 6);
INSERT INTO `rbac_access` VALUES (30, 7);
INSERT INTO `rbac_access` VALUES (30, 8);
INSERT INTO `rbac_access` VALUES (30, 9);
INSERT INTO `rbac_access` VALUES (30, 10);
INSERT INTO `rbac_access` VALUES (30, 11);
INSERT INTO `rbac_access` VALUES (30, 12);
INSERT INTO `rbac_access` VALUES (30, 13);
INSERT INTO `rbac_access` VALUES (30, 14);
INSERT INTO `rbac_access` VALUES (30, 15);
INSERT INTO `rbac_access` VALUES (30, 16);
INSERT INTO `rbac_access` VALUES (30, 17);
INSERT INTO `rbac_access` VALUES (30, 18);
INSERT INTO `rbac_access` VALUES (30, 114);
INSERT INTO `rbac_access` VALUES (30, 115);
COMMIT;

-- ----------------------------
-- Table structure for rbac_menu
-- ----------------------------
DROP TABLE IF EXISTS `rbac_menu`;
CREATE TABLE `rbac_menu` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `title` varchar(45) NOT NULL COMMENT '菜单标题',
  `pid` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '父级ID',
  `image` varchar(100) DEFAULT NULL COMMENT '菜单图片',
  `url` varchar(100) DEFAULT NULL COMMENT '菜单url，分组及模块为空',
  `style` varchar(15) DEFAULT NULL COMMENT '菜单样式',
  `js` varchar(100) DEFAULT NULL COMMENT 'js',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '0目录，1页面，2权限',
  `entitle` varchar(45) NOT NULL COMMENT '英文标题',
  `remark` varchar(100) DEFAULT ' ' COMMENT '备注',
  `sort` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '排序',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1' COMMENT '状态，0禁用，1启用',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=409 DEFAULT CHARSET=utf8 COMMENT='菜单表';

-- ----------------------------
-- Records of rbac_menu
-- ----------------------------
BEGIN;
INSERT INTO `rbac_menu` VALUES (1, '后台', 0, ' ', ' ', '', '', 0, '后台管理', '根目录', 0, 1);
INSERT INTO `rbac_menu` VALUES (2, '系统', 1, NULL, '', NULL, NULL, 0, '角色权限', '角色权限分组', 1, 1);
INSERT INTO `rbac_menu` VALUES (3, '角色管理', 2, '', '/System/role/rolelist', '', '', 1, '角色管理', '入口页面', 1, 1);
INSERT INTO `rbac_menu` VALUES (4, '浏览权限', 3, '', '', '', '', 2, '浏览权限', '绑定相应权限', 1, 1);
INSERT INTO `rbac_menu` VALUES (5, '添加修改权限', 3, '', '', '', '', 2, '添加权限', '绑定相应添加修改权限', 2, 1);
INSERT INTO `rbac_menu` VALUES (6, '删除权限', 3, '', '', '', '', 2, '删除权限', '绑定删除权限', 3, 1);
INSERT INTO `rbac_menu` VALUES (7, '权限管理', 2, NULL, '/System/node/nodelist', NULL, NULL, 1, '权限管理', '入口页面', 2, 1);
INSERT INTO `rbac_menu` VALUES (8, '浏览权限', 7, NULL, '', NULL, NULL, 2, '浏览权限', '绑定页面浏览权限包括添加修改页面', 1, 1);
INSERT INTO `rbac_menu` VALUES (9, '添加修改权限', 7, NULL, '', NULL, NULL, 2, '添加修改权限', '绑定添加修改处理操作权限', 2, 1);
INSERT INTO `rbac_menu` VALUES (10, '删除权限', 7, NULL, '', NULL, NULL, 2, '删除权限', '绑定删除权限', 3, 1);
INSERT INTO `rbac_menu` VALUES (11, '用户管理', 2, NULL, '/System/user/userlist', NULL, NULL, 1, '用户管理', '入口页面', 3, 1);
INSERT INTO `rbac_menu` VALUES (12, '浏览权限', 11, NULL, '', NULL, NULL, 2, '浏览权限', '', 1, 1);
INSERT INTO `rbac_menu` VALUES (13, '添加修改权限', 11, NULL, '', NULL, NULL, 2, '添加修改权限', '', 2, 1);
INSERT INTO `rbac_menu` VALUES (14, '删除权限', 11, NULL, '', NULL, NULL, 2, '删除权限', '', 3, 1);
INSERT INTO `rbac_menu` VALUES (15, '菜单管理', 2, NULL, '/System/menu/menulist', NULL, NULL, 1, '菜单管理', '入口页面', 4, 1);
INSERT INTO `rbac_menu` VALUES (16, '浏览权限', 15, NULL, '', NULL, NULL, 2, '浏览权限', '', 1, 1);
INSERT INTO `rbac_menu` VALUES (17, '添加修改权限', 15, NULL, '', NULL, NULL, 2, '添加修改权限', '', 2, 1);
INSERT INTO `rbac_menu` VALUES (18, '删除权限', 15, NULL, '', NULL, NULL, 2, '删除权限', '', 3, 1);
INSERT INTO `rbac_menu` VALUES (114, '日志管理', 2, NULL, '/system/log/loglist', NULL, NULL, 1, '日志管理', '', 5, 1);
INSERT INTO `rbac_menu` VALUES (115, '浏览权限', 114, NULL, '', NULL, NULL, 2, '浏览权限', '', 1, 1);
COMMIT;

-- ----------------------------
-- Table structure for rbac_menu_node
-- ----------------------------
DROP TABLE IF EXISTS `rbac_menu_node`;
CREATE TABLE `rbac_menu_node` (
  `menu_id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT '菜单ID',
  `node_id` int(10) unsigned NOT NULL COMMENT '权限ID',
  KEY `Index_1` (`menu_id`) USING BTREE,
  KEY `Index_2` (`node_id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=409 DEFAULT CHARSET=utf8 COMMENT='菜单权限关联表';

-- ----------------------------
-- Records of rbac_menu_node
-- ----------------------------
BEGIN;
INSERT INTO `rbac_menu_node` VALUES (4, 63);
INSERT INTO `rbac_menu_node` VALUES (4, 62);
INSERT INTO `rbac_menu_node` VALUES (5, 65);
INSERT INTO `rbac_menu_node` VALUES (6, 99);
INSERT INTO `rbac_menu_node` VALUES (5, 77);
INSERT INTO `rbac_menu_node` VALUES (4, 76);
INSERT INTO `rbac_menu_node` VALUES (8, 75);
INSERT INTO `rbac_menu_node` VALUES (8, 64);
INSERT INTO `rbac_menu_node` VALUES (9, 101);
INSERT INTO `rbac_menu_node` VALUES (9, 66);
INSERT INTO `rbac_menu_node` VALUES (10, 103);
INSERT INTO `rbac_menu_node` VALUES (12, 72);
INSERT INTO `rbac_menu_node` VALUES (12, 71);
INSERT INTO `rbac_menu_node` VALUES (13, 73);
INSERT INTO `rbac_menu_node` VALUES (14, 100);
INSERT INTO `rbac_menu_node` VALUES (16, 107);
INSERT INTO `rbac_menu_node` VALUES (16, 111);
INSERT INTO `rbac_menu_node` VALUES (16, 106);
INSERT INTO `rbac_menu_node` VALUES (17, 110);
INSERT INTO `rbac_menu_node` VALUES (17, 108);
INSERT INTO `rbac_menu_node` VALUES (18, 109);
INSERT INTO `rbac_menu_node` VALUES (115, 231);
INSERT INTO `rbac_menu_node` VALUES (115, 232);
INSERT INTO `rbac_menu_node` VALUES (13, 244);
INSERT INTO `rbac_menu_node` VALUES (13, 105);
COMMIT;

-- ----------------------------
-- Table structure for rbac_node
-- ----------------------------
DROP TABLE IF EXISTS `rbac_node`;
CREATE TABLE `rbac_node` (
  `id` smallint(6) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(50) NOT NULL,
  `title` varchar(50) DEFAULT NULL,
  `status` tinyint(1) DEFAULT '0',
  `remark` varchar(255) NOT NULL,
  `sort` smallint(5) unsigned DEFAULT NULL,
  `pid` smallint(6) unsigned NOT NULL,
  `level` tinyint(1) unsigned NOT NULL,
  `type` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(25) NOT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  KEY `level` (`level`) USING BTREE,
  KEY `pid` (`pid`) USING BTREE,
  KEY `status` (`status`) USING BTREE,
  KEY `name` (`name`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=707 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of rbac_node
-- ----------------------------
BEGIN;
INSERT INTO `rbac_node` VALUES (60, 'System', '系统管理', 1, '', 1, 0, 1, 0, '');
INSERT INTO `rbac_node` VALUES (62, 'addRole', '角色添加/修改', 1, '', 2, 211, 3, 0, '');
INSERT INTO `rbac_node` VALUES (63, 'roleList', '角色管理', 1, '', 1, 211, 3, 0, '');
INSERT INTO `rbac_node` VALUES (64, 'addNode', '权限添加', 1, '该功能只有sysadmin可以操作', 2, 212, 3, 0, '');
INSERT INTO `rbac_node` VALUES (65, 'addRoleHandle', '角色添加/修改处理', 1, '', 3, 211, 3, 0, '');
INSERT INTO `rbac_node` VALUES (66, 'addNodeHandle', '权限添加处理', 1, '该功能只有sysadmin可以操作', 3, 212, 3, 0, '');
INSERT INTO `rbac_node` VALUES (71, 'userList', '用户管理', 1, '', 1, 213, 3, 0, '');
INSERT INTO `rbac_node` VALUES (72, 'addUser', '用户添加/修改', 1, '', 2, 213, 3, 0, '');
INSERT INTO `rbac_node` VALUES (73, 'addUserHandle', '用户添加/修改处理', 1, '', 4, 213, 3, 0, '');
INSERT INTO `rbac_node` VALUES (75, 'nodelist', '权限管理', 1, '该功能只有sysadmin可以操作', 1, 212, 3, 0, '');
INSERT INTO `rbac_node` VALUES (76, 'access', '权限配置', 1, '', 5, 211, 3, 0, '');
INSERT INTO `rbac_node` VALUES (77, 'setAccessHandle', '权限配置处理', 1, '', 6, 211, 3, 0, '');
INSERT INTO `rbac_node` VALUES (99, 'deleteRoleHandle', '角色删除处理', 1, '', 4, 211, 3, 0, '');
INSERT INTO `rbac_node` VALUES (100, 'deleteUserHandle', '用户删除处理', 1, '', 5, 213, 3, 0, '');
INSERT INTO `rbac_node` VALUES (101, 'updateNodeAjaxHandle', '权限修改-ajax处理', 1, '该功能只有sysadmin可以操作', 4, 212, 3, 0, '');
INSERT INTO `rbac_node` VALUES (103, 'deleteNodeHandle', '权限删除处理', 1, '该功能只有sysadmin可以操作', 5, 212, 3, 0, '');
INSERT INTO `rbac_node` VALUES (105, 'updateUserAjaxHandle', '用户修改-ajax处理', 1, '', 3, 213, 3, 0, '');
INSERT INTO `rbac_node` VALUES (106, 'menulist', '菜单管理', 1, '', 1, 214, 3, 0, '');
INSERT INTO `rbac_node` VALUES (107, 'addMenu', '菜单添加/修改', 1, '', 2, 214, 3, 0, '');
INSERT INTO `rbac_node` VALUES (108, 'addMenuHandle', '菜单添加/修改处理', 1, '', 3, 214, 3, 0, '');
INSERT INTO `rbac_node` VALUES (109, 'deleteMenuHandle', '菜单删除处理', 1, '', 5, 214, 3, 0, '');
INSERT INTO `rbac_node` VALUES (110, 'updateMenuAjaxHandle', '菜单修改-ajax处理', 1, '', 4, 214, 3, 0, '');
INSERT INTO `rbac_node` VALUES (111, 'getMenuListJson', '菜单添加/修改-获取父级json列表', 1, '浏览权限', 6, 214, 3, 0, '');
INSERT INTO `rbac_node` VALUES (211, 'Role', '角色管理', 1, '', 1, 60, 2, 0, '');
INSERT INTO `rbac_node` VALUES (212, 'Node', '权限管理', 1, '', 2, 60, 2, 0, '');
INSERT INTO `rbac_node` VALUES (213, 'User', '用户管理', 1, '', 3, 60, 2, 0, '');
INSERT INTO `rbac_node` VALUES (214, 'Menu', '菜单管理', 1, '', 4, 60, 2, 0, '');
INSERT INTO `rbac_node` VALUES (230, 'Log', '日志管理', 1, '', 5, 60, 2, 0, '');
INSERT INTO `rbac_node` VALUES (231, 'loglist', '操作日志', 1, '', 1, 230, 3, 0, '');
INSERT INTO `rbac_node` VALUES (232, 'logdetails', '日志详细', 1, '', 2, 230, 3, 0, '');
INSERT INTO `rbac_node` VALUES (244, 'checkloginname', '用户名验证', 1, '', 6, 213, 3, 0, '');
COMMIT;

-- ----------------------------
-- Table structure for rbac_role
-- ----------------------------
DROP TABLE IF EXISTS `rbac_role`;
CREATE TABLE `rbac_role` (
  `id` smallint(6) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(40) NOT NULL,
  `remark` varchar(255) DEFAULT NULL,
  `ename` varchar(40) DEFAULT NULL,
  `create_time` int(11) unsigned NOT NULL,
  `update_time` int(11) unsigned NOT NULL,
  `create_by` varchar(45) NOT NULL DEFAULT ' ' COMMENT '创建者账号',
  `type` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '类型：0：系统预置，1：自定义',
  `grade` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '等级：1:soooner,2:网络服务商,3:SP',
  `status` tinyint(1) unsigned NOT NULL DEFAULT '1',
  `pid` int(10) unsigned NOT NULL DEFAULT '0',
  `vdgo_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT '所属运营商ID',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `ename` (`ename`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=59 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of rbac_role
-- ----------------------------
BEGIN;
INSERT INTO `rbac_role` VALUES (5, '系统管理员', '系统管理权限', '系统管理员', 0, 1504680005, 'sysadmin', 0, 0, 1, 0, 0);
INSERT INTO `rbac_role` VALUES (30, 'SOOONER', 'SOOONER角色', 'soooner', 1385362987, 1542250100, 'sysadmin', 0, 1, 1, 0, 0);
COMMIT;

-- ----------------------------
-- Table structure for rbac_role_user
-- ----------------------------
DROP TABLE IF EXISTS `rbac_role_user`;
CREATE TABLE `rbac_role_user` (
  `role_id` mediumint(9) unsigned DEFAULT NULL,
  `user_id` char(32) DEFAULT NULL,
  KEY `group_id` (`role_id`) USING BTREE,
  KEY `user_id` (`user_id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of rbac_role_user
-- ----------------------------
BEGIN;
INSERT INTO `rbac_role_user` VALUES (5, '31');
INSERT INTO `rbac_role_user` VALUES (5, '36');
INSERT INTO `rbac_role_user` VALUES (30, '37');
COMMIT;

-- ----------------------------
-- Table structure for rbac_user
-- ----------------------------
DROP TABLE IF EXISTS `rbac_user`;
CREATE TABLE `rbac_user` (
  `id` smallint(5) unsigned NOT NULL AUTO_INCREMENT,
  `account` varchar(64) NOT NULL,
  `nickname` varchar(50) NOT NULL,
  `password` char(32) NOT NULL,
  `last_login_time` int(11) unsigned DEFAULT '0',
  `last_login_ip` varchar(40) DEFAULT NULL,
  `login_count` mediumint(8) unsigned DEFAULT '0',
  `email` varchar(50) NOT NULL,
  `remark` varchar(255) NOT NULL,
  `create_time` int(11) unsigned NOT NULL,
  `update_time` int(11) unsigned NOT NULL,
  `status` tinyint(1) DEFAULT '0',
  `create_by` varchar(45) DEFAULT ' ',
  `my_vdgo_id` smallint(5) unsigned NOT NULL DEFAULT '0' COMMENT '自己所属网络服务商列表',
  `grade` tinyint(1) unsigned NOT NULL DEFAULT '0' COMMENT '等级：1:SOOONER,2:网络服务商,3:SP',
  `other_vdgo_ids` varchar(100) NOT NULL COMMENT '其他网络服务商列表，以逗号隔开',
  `tel` varchar(45) NOT NULL COMMENT '电话',
  `biz_list` text NOT NULL COMMENT '业务列表，以逗号隔开（新版弃用该字段，使用vsdn_sp_user_map进行绑定）',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `account` (`account`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=105 DEFAULT CHARSET=utf8;

-- ----------------------------
-- Records of rbac_user
-- ----------------------------
BEGIN;
INSERT INTO `rbac_user` VALUES (31, 'superadmin', '超级管理员', 'd3900f8a564af809627cba142b141e8c', 1560144766, '192.168.1.95', 510, '', '', 1382518991, 0, 1, 'sysadmin', 0, 0, '', '', '');
INSERT INTO `rbac_user` VALUES (36, 'sysadmin', '系统管理员', 'e6e11a659ef22be677ff29cc2f0ff438', 1489719674, '59.108.46.205', 1120, '', '', 1384850751, 1394440727, 1, 'sysadmin', 0, 0, '', '', '');
INSERT INTO `rbac_user` VALUES (37, 'root', 'root', '963fd22d7afcaa22dc23f48f349b49ce', 1418786402, '59.108.46.205', 126, '', '', 1385367162, 0, 1, 'sysadmin', 0, 1, '', '', '');
COMMIT;

SET FOREIGN_KEY_CHECKS = 1;
