/*
 ** 时间戳转换成指定格式日期
 ** eg.
 ** dateFormat(11111111111111, 'Y年m月d日 H时i分')
 ** → "2322年02月06日 03时45分"
 */
var dateFormat = function (timestamp, formats) {
    timestamp=timestamp*1000;//转成毫秒
    // formats格式包括 //
    // 1. Y-m-d //
    // 2. Y-m-d H:i:s
    // 3. Y年m月d日
    // 4. Y年m月d日 H时i分
    formats = formats || 'Y-m-d';
    var zero = function (value) {
        if (value < 10) {
            return '0' + value; }
            return value;
    };
    var myDate = timestamp? new Date(timestamp): new Date();
    var year = myDate.getFullYear();
    var month = zero(myDate.getMonth() + 1);
    var day = zero(myDate.getDate());
    var hour = zero(myDate.getHours());
    var minite = zero(myDate.getMinutes());
    var second = zero(myDate.getSeconds());
    return formats.replace(/Y|m|d|H|i|s/ig, function (matches) {
        return ({ Y: year, m: month, d: day, H: hour, i: minite, s: second })[matches];
    });
};
/**
 * 20181101120000 -> 时间戳(秒)
 * @param date
 * @returns {Number}
 */
var dateFormatYmdHis2Timestamp = function (date) {
    var str = dateFormatYmdHis2Y_m_d_H_i_s(date);
    //alert(str);
    var mydate = new Date(str);
    var timestamp=parseInt(Date.parse(mydate)/1000);

    return timestamp;
};
/**
 * 20181101120000 -> 2018-11-01 12:00:00
 * @param date
 * @returns {string}
 */
var dateFormatYmdHis2Y_m_d_H_i_s = function (date) {
    var year = date.substr(0,4);
    var month =date.substr(4,2);
    var day = date.substr(6,2);
    var hour = date.substr(8,2);
    var minite = date.substr(10,2);
    var second = date.substr(12,2);
    var str = year+"-"+month+"-"+day+" "+hour+":"+minite+":"+second;
    return str;
};
/**
 * 20181101120000 -> 2018-11-01 12:00:00
 * @param date
 * @returns {string}
 */
var dateFormatY_m_d_H_i_s2YmdHis = function (date) {

        var date = new Date(date);
        var Y = date.getFullYear() + '';
        var M = (date.getMonth()+1 < 10 ? '0'+(date.getMonth()+1) : date.getMonth()+1) + '';
        var D = (date.getDate() < 10 ? '0'+(date.getDate()) : date.getDate()) + '';
        var h = (date.getHours() < 10 ? '0'+(date.getHours()) : date.getHours()) + '';
        var m = (date.getMinutes() < 10 ? '0'+(date.getMinutes()) : date.getMinutes()) + '';
        var s = (date.getSeconds() < 10 ? '0'+(date.getSeconds()) : date.getSeconds());
        return Y+M+D+h+m+s;

};